package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.ui.Keyboard;
  import flash.text.TextFormat;
  import component.Button;
  import component.ComboBox;
  import wmap.AEPMap;
  import wmap.ECPMap;
  import wmap.GlobeMap;
  import wmap.MollweideMap;

//--------------------------------------------------------------------//
// ANVǗNX
  public class WorldMapActionManager{

// gEk
    public static const RADIUS_COEF:Number=1.2;

// _oxω
    public static const THETA_X:Number=15.0;

// _ܓxω
    public static const THETA_Y:Number=10.0;

// Xe[W
    internal var stage:Stage;

// n}\f
    internal var view:WorldViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// \[hؑփR{{bNX
    internal var mode:ComboBox;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - n}\f
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function WorldMapActionManager(sprite:Sprite,
      	      	      	      	      	  view:WorldViewModel,
      	      	      	      	      	  x:int,y:int,width:int,
      	      	      	      	      	  textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;
      textFormat.color=fgColor;

      var maps:Vector.<String>=new Vector.<String>(4,true);
      maps[0]=GlobeMap.NAME;
      maps[1]=ECPMap.NAME;
      maps[2]=MollweideMap.NAME;
      maps[3]=AEPMap.NAME;

      var w:int=width/5;
      mode=new ComboBox(maps,fgColor,bgColor,x,y,textFormat,
      	      	      	ComboBox.ABOVE,view.viewMode);
      var zoomin:Button=new Button("zoom in",fgColor,bgColor,
      	      	      	      	   x+w,y,textFormat);
      var zoomout:Button=new Button("zoom out",fgColor,bgColor,
      	      	      	      	    x+2*w,y,textFormat);
      var moveCenter:Button=new Button("move center",fgColor,bgColor,
      	      	      	      	       x+3*w,y,textFormat);
      var clearBoard:Button=new Button("clear",fgColor,bgColor,
      	      	      	      	       x+4*w,y,textFormat);

      mode.addEventListener(ComboBox.SELECT,changeMode);
      zoomin.addEventListener(MouseEvent.CLICK,zoomIn);
      zoomout.addEventListener(MouseEvent.CLICK,zoomOut);
      moveCenter.addEventListener(MouseEvent.CLICK,center);
      clearBoard.addEventListener(MouseEvent.CLICK,clear);

      sprite.addChild(mode);
      sprite.addChild(zoomin);
      sprite.addChild(zoomout);
      sprite.addChild(moveCenter);
      sprite.addChild(clearBoard);

    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
      view.addNameBoard(mx,my);
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	view.model.map.rotate(mx-stage.mouseX,stage.mouseY-my);
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_4:
      	case Keyboard.LEFT:
      	  view.model.map.rotateMap(THETA_X,0);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_6:
      	case Keyboard.RIGHT:
      	  view.model.map.rotateMap(-THETA_X,0);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_2:
      	case Keyboard.DOWN:
      	  view.model.map.rotateMap(0,THETA_Y);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_8:
      	case Keyboard.UP:
      	  view.model.map.rotateMap(0,-THETA_Y);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_1:
      	case Keyboard.NUMBER_1:
      	case Keyboard.NUMPAD_ADD:
      	case Keyboard.SEMICOLON:
      	  view.zoom(RADIUS_COEF);
      	  break;
      	case Keyboard.NUMPAD_0:
      	case Keyboard.NUMBER_0:
      	case Keyboard.NUMPAD_SUBTRACT:
      	case Keyboard.MINUS:
      	  view.zoom(1.0/RADIUS_COEF);
      	  break;
      	case Keyboard.NUMPAD_5:
      	case Keyboard.NUMBER_5:
      	case Keyboard.C:
      	  view.moveCenter();
      	  break;
      	case Keyboard.D:
      	  view.clearBoard();
      	  break;
      }
    }

//--------------------------------------------------------------------//
// g傷
    internal function zoomIn(event:Event):void{
      view.zoom(RADIUS_COEF);
    }

//--------------------------------------------------------------------//
// k
    internal function zoomOut(event:Event):void{
      view.zoom(1.0/RADIUS_COEF);
    }

//--------------------------------------------------------------------//
// |C^ʒu𒆐SɈړ
    internal function center(event:Event):void{
      view.moveCenter();
    }

//--------------------------------------------------------------------//
// ̈於\
    internal function clear(event:Event):void{
      view.clearBoard();
    }

//--------------------------------------------------------------------//
// \[h؂ւ
    internal function changeMode(event:Event):void{
      if(view.viewMode==mode.index) return;
      view.viewMode=mode.index;
      switch(view.viewMode){
      	case WorldViewModel.GLOBE:
      	  view.model.setMap(new GlobeMap());
      	  view.draw();
      	  break;
      	case WorldViewModel.ECP:
      	  view.model.setMap(new ECPMap());
      	  view.draw();
      	  break;
      	case WorldViewModel.MOLLWEIDE:
      	  view.model.setMap(new MollweideMap());
      	  view.draw();
      	  break;
      	case WorldViewModel.AEP:
      	  view.model.setMap(new AEPMap());
      	  view.draw();
      	  break;
      }
    }
  }
}
