package{
  import flash.display.BitmapData;
  import flash.display.Sprite;
  import flash.geom.Point;
  import flash.text.TextFormat;
  import wmap.Map2D;
  import wmap.GlobeMap;

//--------------------------------------------------------------------//
// Q}bvf[^f
  public class WorldMapModel{

// Qn}f[^
    public var data:WorldMapData;

// eLXg
    public var textFormat:TextFormat;

// Qn}f[^
    public var map:Map2D;

// }bv̈
    public var regions:Vector.<Region>;

// ʕ\摜
    public var image:BitmapData;

// _px
    public var theta:Number;
    public var phy:Number;

// |C^
    public var pointer:Point;

// ̈於\i[}bv
    protected var boardMap:Object;

//--------------------------------------------------------------------//
// width,height - ʕA
// textFormat - eLXg
    public function WorldMapModel(width:int,height:int,textFormat:TextFormat):void{
      this.textFormat=textFormat;
      data=null;
      regions=null;
      image=new BitmapData(width,height,false,0x000000);
      map=new GlobeMap(135.0,0.0);
      map.setSize(width,height);
      theta=135.0;
      phy=0.0;
      pointer=new Point();
      boardMap=new Object();
    }

//--------------------------------------------------------------------//
// Qn}ݒ肷
    public function setMap(map:Map2D):void{
      map.copy(this.map);
      this.map=map;
    }

//--------------------------------------------------------------------//
// Qn}f[^ݒ肷
    public function setData(data:WorldMapData):void{
      this.data=data;
    }

//--------------------------------------------------------------------//
// }bv̈̐ݒ肷
    public function setRegionsCount(count:int):void{
      regions=new Vector.<Region>(count,true);
    }

//--------------------------------------------------------------------//
// }bv̈ݒ肷
    public function setRegion(index:int,region:Region):void{
      regions[index]=region;
    }

//--------------------------------------------------------------------//
// |C^ʒu𒆐SɈړ
    public function moveCenter():void{
      var x:Number=pointer.x/Number(data.base.width)-0.5;
      var y:Number=0.5-pointer.y/Number(data.base.height);
      map.setLocation(360.0*x,180.0*y);
    }

//--------------------------------------------------------------------//
// }bv̈̃CfbNXԂ
    public function getRegion(x:int,y:int):int{
      var p:Point=map.getPoint(data.base,x,y);
      if(p==null){
      	return -1;
      }
      else{
      	pointer=p.clone();
      	return data.base.getPixel(p.x,p.y);
      }
    }

//--------------------------------------------------------------------//
// ̈於\
// sprite - eXvCg
  public function clearBoard(sprite:Sprite):void{
    for(var key:Object in boardMap){
      sprite.removeChild(boardMap[key]);
      delete boardMap[key];
    }
  }

//--------------------------------------------------------------------//
// ̈於\ǉ
// sprite - eXvCg
// x,y - \ʒu
    public function addNameBoard(sprite:Sprite,x:int,y:int):void{
      var pt:int=getRegion(x,y);
      if(pt>1){
      	if(boardMap[regions[pt].name]==null){
      	  boardMap[regions[pt].name]=
      	    new NameBoard(regions[pt],pointer.clone(),textFormat);
      	  sprite.addChild(boardMap[regions[pt].name]);
      	}
      	else{
      	  boardMap[regions[pt].name].x=pointer.x;
      	  boardMap[regions[pt].name].y=pointer.y;
      	}
      	setImage();
      }
    }

//--------------------------------------------------------------------//
// ʃsNZf[^ݒ肷
    public function setImage():void{
      image.lock();
      for(var i:int=0;i<image.width;i++){
      	for(var j:int=0;j<image.height;j++){
      	  var p:Point=map.getPoint(data.base,i,j);
      	  if(p==null){
      	    image.setPixel(i,j,data.bgColor);
      	  }
      	  else{
      	    var index:int=data.base.getPixel(p.x,p.y);
      	    image.setPixel(i,j,regions[index].color);
      	  }
      	}
      }
      image.unlock();
      for(var key:Object in boardMap){
      	p=boardMap[key].pointer;
      	p=map.getViewPoint(data.base,p.x,p.y);
      	if(p==null){
      	  boardMap[key].visible=false;
      	}
      	else{
      	  boardMap[key].x=p.x;
      	  boardMap[key].y=p.y;
      	  boardMap[key].visible=true;
      	  if(boardMap[key].x+boardMap[key].width>image.width){
      	    boardMap[key].x-=boardMap[key].width;
      	  }
      	  if(boardMap[key].y+boardMap[key].height>image.height){
      	    boardMap[key].y-=boardMap[key].height;
      	  }
      	}
      }
    }
  }
}
