package wmap{
  import flash.display.BitmapData;
  import flash.geom.Point;

//--------------------------------------------------------------------//
// nV
  public class GlobeMap extends Map2D{

// nV\
    public static const NAME:String="Globe";

    public function GlobeMap(theta:Number=0.0,phy:Number=0.0):void{
      super(theta,phy);
    }

//--------------------------------------------------------------------//
// f[^Rs[
// map - Qƌ̃f[^
    public override function copy(map:Map2D):void{
      super.copy(map);
      vx=90.0/radius;
      vy=vx;
    }

//--------------------------------------------------------------------//
// nV̔aݒ肷
    public override function setRadius(radius:int):void{
      super.setRadius(radius);
      vx=90.0/radius;
      vy=vx;
    }

//--------------------------------------------------------------------//
// n}̗̈CfbNXԂ
// base - f[^
// x,y - ʏ̑Έʒu
    public override function getPoint(base:BitmapData,
      	      	      	      	      x:Number,y:Number):Point{
      x=(x-cx)/Number(radius);
      y=(cy-y)/Number(radius);
      var r2:Number=1.0-(x*x+y*y);
      if(r2<0.0) return null;

      var sphy:Number=Math.sin(TO_RADIAN*phy);
      var cphy:Number=Math.cos(TO_RADIAN*phy);
      var r:Number=Math.sqrt(r2);
      var ssy:Number=sphy*r+cphy*y;
      var ccy:Number=1.0-ssy*ssy;
      if(ccy<TOLERANCE){
      	if(ssy>0.0){	// kɓ_
      	  point.x=0;
      	  point.y=0;
      	}
      	else{		// ɓ_
      	  point.x=base.width-1;
      	  point.y=base.height-1;
      	}
      }
      else{
      	var yy:Number=PI_INV*Math.asin(ssy);
      	var ccx:Number=(cphy*r-sphy*y)/Math.sqrt(ccy);
      	var xx:Number=0.0;
      	if(ccx<-1.0+TOLERANCE)      xx=0.5;
      	else if(ccx<=1.0-TOLERANCE) xx=0.5*PI_INV*Math.acos(ccx);
      	if(x<0) xx=-xx;
      	var i:int=base.width/2+int(base.width*(1.0+xx+theta/360.0));
      	var j:int=base.height/2-int(base.height*yy);
      	point.x=i%base.width;
      	point.y=j;
      }
      return point;
    }

//--------------------------------------------------------------------//
// n}̈ʒuԂ
// base - f[^
// x,y - f[^ʒu
    public override function getViewPoint(base:BitmapData,
      	      	      	      	      	  x:int,y:int):Point{
      var rx:Number=2.0*Math.PI*(Number(x)/Number(base.width)-0.5);
      var ry:Number=Math.PI*(Number(y)/Number(base.height)-0.5);
      var cry:Number=Math.cos(ry);
      var px:Number=Math.cos(rx)*cry;
      var py:Number=Math.sin(rx)*cry;
      var pz:Number=Math.sin(ry);
      var stheta:Number=Math.sin(TO_RADIAN*theta);
      var ctheta:Number=Math.cos(TO_RADIAN*theta);
      var sphy:Number=Math.sin(TO_RADIAN*phy);
      var cphy:Number=Math.cos(TO_RADIAN*phy);
      var temp:Number=px*ctheta+py*stheta;
      var px2:Number=-px*stheta+py*ctheta;
      var py2:Number=temp*sphy+pz*cphy;
      var pz2:Number=temp*cphy-pz*sphy;
      if(pz2<0.0){
      	return null;
      }
      else{
      	point.x=int(radius*px2+cx);
      	point.y=int(radius*py2+cy);
      	return point;
      }
    }
  }
}
