package wmap{
  import flash.display.BitmapData;
  import flash.geom.Point;

//--------------------------------------------------------------------//
// Cf}@
  public class MollweideMap extends Map2D{

// Cf}@\
    public static const NAME:String="Mollweide";

// Cf}@̕`TCY
    protected var molWidth:int;
    protected var molHeight:int;

    public function MollweideMap(theta:Number=0.0,phy:Number=0.0):void{
      super(theta,phy);
      molWidth=0;
      molHeight=0;
    }

//--------------------------------------------------------------------//
// f[^Rs[
// map - Qƌ̃f[^
    public override function copy(map:Map2D):void{
      super.copy(map);
      molWidth=4*width/5;
      molHeight=4*height/5;
      vx=360.0/Number(width);
      vy=0.0;
    }

//--------------------------------------------------------------------//
// `TCYݒ肷
// width,height - ʕA
    public override function setSize(width:int,height:int):void{
      super.setSize(width,height);
      molWidth=4*width/5;
      molHeight=4*height/5;
      vx=360.0/molWidth;
      vy=0.0;
    }

//--------------------------------------------------------------------//
// n}̗̈CfbNXԂ
// base - f[^
// x,y - ʏ̑Έʒu
    public override function getPoint(base:BitmapData,
      	      	      	      	      x:Number,y:Number):Point{
      x=2.0*(x-cx)/Number(molWidth);
      y=2.0*(cy-y)/Number(molHeight);
      if(x*x+y*y>=1.0){
      	return null;
      }
      else if(y>1.0-TOLERANCE){		// kɓ_
      	point.x=0;
      	point.y=0;
      }
      else if(y<-1.0+TOLERANCE){	// ɓ_
      	point.x=base.width-1;
      	point.y=base.height-1;
      }
      else{
      	var xx:Number=x/Math.sqrt(1.0-y*y);
      	var yy:Number=2.0*Math.asin(y);
      	yy=PI_INV*Math.asin(PI_INV*(yy+Math.sin(yy)));
      	var i:int=3*base.width/2+int(base.width*(0.5*xx+theta/360.0));
      	var j:int=base.height/2-int(base.height*yy);
      	point.x=i%base.width;
      	point.y=j;
      }
      return point;
    }

//--------------------------------------------------------------------//
// n}̈ʒuԂ
// base - f[^
// x,y - f[^ʒu
    public override function getViewPoint(base:BitmapData,
      	      	      	      	      	  x:int,y:int):Point{
      var xx:Number=2.0*(Number(x)/Number(base.width)-0.5-theta/360.0);
      if(xx>1.0)       xx-=2.0;
      else if(xx<-1.0) xx+=2.0;
      var ey:Number=1.0;
      if(y==0){
      	ey=-1.0;
      }
      else if(y<height-1){
      	ey=Math.PI*(Number(y)/Number(base.height)-0.5);
      	ey=Math.sin(0.5*eccentricAnomaly(Math.PI*Math.asin(ey),-1.0));
      }
      var ex:Number=xx*Math.sqrt(1.0-ey*ey);
      point.x=int(0.5*molWidth*ex+cx);
      point.y=int(0.5*molHeight*ey+cy);
      return point;
    }

//--------------------------------------------------------------------//
// Newtion @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
    internal function eccentricAnomaly(m:Number,eccen:Number):Number{
      var ei:Number=m+eccen*Math.sin(m);
      var mi:Number=ei-eccen*Math.sin(ei);
      var dm:Number=Math.abs(m-mi);
      while(dm>TOLERANCE){
        ei=ei+(m-mi)/(1.0-eccen*Math.cos(ei));
        mi=ei-eccen*Math.sin(ei);
        dm=Math.abs(m-mi);
      }
      return ei;
    }
  }
}
